#include "GeneAssoc.h"
#include "Constant.h"
#include "math.h"
#include <string>
#include <cstring>
#include <iostream>
#include <stdlib.h>
#include "qfc.h"
#include "MixChidist.h"
#define MATHLIB_STANDALONE
#include <Rmath.h>
#include <Eigen/SVD>

bool GeneAssoc::burden = false;
bool GeneAssoc::SKAT = false;
bool GeneAssoc::SKATO = false;
bool GeneAssoc::VT = false;
bool GeneAssoc::longOutput = false;

double GeneAssoc::maf = 0.05;
double GeneAssoc::MAC = 4;

String GeneAssoc::WT = "unit";

int GeneAssoc::RunAssoc(Pedigree & ped, FastTransform & trans, FastFit & engine,String & traitName,GroupFromAnnotation & group,FILE * log)
{
   if(!burden && !SKAT && !SKATO && !VT)
      return 0;
   if(group.annoGroups.Length()==0)
   {
      error("No genes or groups to test.\n");
   }

   for(int i=0;i<group.annoGroups.Length();i++)
   {
      if(i%1000==1 && i>1000)
      {
	 printf("Finished analyzing %d genes.\n",((int)i/1000)*1000);
	 fprintf(log,"Finished analyzing %d genes.\n",((int)i/1000)*1000);
      }
      String geneName = group.annoGroups[i];
      if(!GetGenotypeVector(trans,ped,group,i))
      {
	 printf("Warning: no qualified variant to group for gene %s.\n",geneName.c_str());
	 fprintf(log,"Warning: no qualified variant to group for gene %s.\n",geneName.c_str());
	 continue;
      }

      CalculateU(trans,geneName,engine,genotype,ped);
      CalculateV(trans,geneName,engine,genotype,ped);
      if(longOutput)
      {
	 CalculateSingleVarStat(trans,geneName,engine,genotype,ped);
      }

      //construct gene-level test statistics from single variant test statistics
      if(burden)
      {
	 BurdenAssoc(trans,geneName,engine,genotype,ped);
      }

      if(SKAT)
      {
	 SKATassoc(trans,geneName,engine,genotype,ped);
      }

      if(VT)
      {
	 VTassoc(trans,geneName,engine,genotype,ped);
      }
   }
}

void GeneAssoc::CalculateSingleVarStat(FastTransform & trans,String & geneName,FastFit & engine,Eigen::MatrixXf & genotypeSKAT,Pedigree & ped)
{

}

void GeneAssoc::CalculateU(FastTransform & trans,String & geneName,FastFit & engine,Eigen::MatrixXf & genotypeSKAT,Pedigree & ped)
{

}

void GeneAssoc::CalculateV(FastTransform & trans,String & geneName,FastFit & engine,Eigen::MatrixXf & genotypeSKAT,Pedigree & ped)
{

}
